RRCHL:				;bitshifting include file by Jon Martin
 srl h				;accumulator destroyed in some cases
 rr l				;note: carry flag may not be affected as defined
 ret nc
 set 7,h
 ret
RRCDE:
 srl d
 rre
 ret nc
 set 7,d
 ret
RRCBC:
 srl b
 rr c
 ret nc
 set 7,b
 ret
RLCHL:
 sla l
 rl h
 ret nc
 set 0,l
 ret
RLCDE:
 sla e
 rl d
 ret nc
 set 0,e
 ret
RLCBC:
 sla c
 rl b
 ret nc
 set 0,c
 ret
SRLHL:
 srl h
 rr l
 ret
SRLDE:
 srl d
 rr e
 ret
SRLBC:
 srl b
 rr c
 ret
SLLHL:
 sla l
 rl h
 set 0,l
 ret
SLLDE:
 sla e
 rl d
 set 0,e
 ret
SLLBC:
 sla c
 rl b
 set 0,c
 ret
SRAHL:
 ld a,h
 rra
 rr l
 rla
 and 128
 or h
 ld h,a
 ret
SRADE:
 ld a,d
 rra
 rr e
 rla
 and 128
 or d
 ld d,a
 ret
SRABC:
 ld a,b
 rra
 rr c
 rla
 and 128
 or b
 ld b,a
 ret
SLAHL:
 add hl,hl
 ret
SLADE:
 sla e
 rl d
 ret
SLABC:
 sla c
 rl b
 ret
RRHL:
 rr h
 rr l
 ret
RRDE:
 rr d
 rr e
 ret
RRBC:
 rr b
 rr c
 ret
RLHL:
 rl l
 rl h
 ret
RLDE:
 rl e
 rl d
RLBC:
 rl c
 rl b
 ret 
SLLA:
 sla a
 set 0,a
 ret
SLLB:
 sla b
 set 0,b
 ret 
SLLC:
 sla c
 set 0,c
 ret
SLLD:
 sla d
 set 0,d
 ret
SLLE:
 sla e
 set 0,e
 ret
SLLLOCHL:
 sla (HL)
 set 0,(HL)
 ret