;2-byte (across) sprite xor routine by Jon Martin
;optimized to be faster than Joe Wingbermeuhle's largesprite routine
;based on the 1-byte xor routine from "learn ti 83+ asm in 28 days"
;inputs:
;a=xc
;e=yc
;b=height
;IX=sprite pointer
;destroys all except shadow registers
DoubleSprite:				
 ld h,0	 		;7		
 ld l,e			;4		
 ld d,h 		;4
 add hl,hl		;11
 add hl,de		;11
 add hl,hl		;11
 add hl,hl		;11
 ld de,plotsscreen	;10
 add hl,de		;11
 ld e,a			;4
 srl e			;8
 srl e			;8
 srl e			;8
 ld d,0			;7
 add hl,de		;11
 ld d,h			;4
 ld e,l			;4
 and 7			;4
 jp z,aligned		;10
 ld c,a			;4
 ld de,12		;10
rowloop:		;total: 194
 push bc		;11
 ld b,c 		;4
 xor a			;4
 ld d,(ix)		;19
 ld e,(ix+1)		;19
shiftloop:		;60 per loop
 srl d			;8
 rr e			;8
 rra			;4
 djnz shiftloop		;13/8,37 per loop
 inc hl
 inc hl
 xor (hl)
 ld (hl),a
 ld a,e
 dec hl
 xor (hl)
 ld (hl),a
 ld a,d
 dec hl
 xor (hl)
 ld (hl),a	
 pop bc			;10
 ld de,12		;10
 add hl,de		;11
 inc ix			;10
 inc ix			;10
 djnz rowloop		;13/8
 ret			;10
aligned:
 ld de,11 
alignedloop:
 ld a,(ix)
 xor (hl)
 ld (hl),a
 ld a,(ix+1)
 inc hl
 xor (hl)
 ld (hl),a
 add hl,de
 inc ix
 inc ix
 djnz alignedloop
 ret   
.end